%
% This function plots axis labels in nicer format for quality
% printing on colour printers.
%
% Increase axis label sizes
% Embolden plotted lines
% Make on-plot text larger
% Make axis labels italicized, larger, and moved away from axes
%

% 
% Paul Fieguth
% November, 1998
%


function nice_plot

for hf=get(gcf,'Children')',
  for hl=get(hf,'Children')',
    if (strcmp(get(hl,'Type'),'line')),
      set(hl,'LineWidth',2.0);
    end;
    if (strcmp(get(hl,'Type'),'text')),
      set(hl,'HorizontalAlignment','center','VerticalAlignment','middle','FontName', 'Times','Fontsize', 16);
    end;
  end;
end;
set(gca,'Fontsize',12);
set(get(gca,'XLabel'), 'Fontsize', 16, 'FontAngle', 'Italic', 'FontName', 'Times', 'VerticalAlignment','top');
set(get(gca,'YLabel'), 'Fontsize', 16, 'FontAngle', 'Italic', 'FontName', 'Times', 'VerticalAlignment','bottom');
set(get(gca,'Title'), 'Fontsize', 21, 'FontAngle', 'Italic', 'FontName', 'Times' );

