seed = 1;
rand('state', seed);
randn('state', seed);

N = 4; 
dag = zeros(N,N);
C = 1; S = 2; R = 3; W = 4;
dag(C,[R S]) = 1;
dag(R,W) = 1;
dag(S,W)=1;

false = 1; true = 2;
ns = 2*ones(1,N); % binary nodes

bnet = mk_bnet(dag, ns);
if 0
  bnet.CPD{C} = tabular_CPD(bnet, C, [0.5 0.5]);
  bnet.CPD{R} = tabular_CPD(bnet, R, [0.8 0.2 0.2 0.8]);
  bnet.CPD{S} = tabular_CPD(bnet, S, [0.5 0.9 0.5 0.1]);
  bnet.CPD{W} = tabular_CPD(bnet, W, [1 0.1 0.1 0.01 0 0.9 0.9 0.99]);
else
  for i=1:N, bnet.CPD{i} = tabular_CPD(bnet, i); end
end

engine = {};
engine{1} = jtree_inf_engine(bnet);
engine{2} = var_elim_inf_engine(bnet);
E = length(engine);

evidence = cell(1,N);
onodes = [1 3];
data = sample_bnet(bnet);
evidence(onodes) = data(onodes);

mpe = cell(1,1);
ll = [];
[mpe{1}, ll(1)] = calc_mpe(engine{1}, evidence);
[mpe{2}, ll(2)] = calc_mpe(engine{2}, evidence);
[mpe{3}, ll(3)] = calc_mpe_global(bnet, evidence);
%[mpe{4}, ll(4)] = calc_mpe_bucket(bnet, evidence);
nsolns = size(mpe{3}, 1)

for e=1:3
  cell2num(mpe{e})
end

t1 = cell2num(mpe{1});
for e=2:3
  assert(approxeq(ll(1), ll(e)));
  te = cell2num(mpe{e});
  %assert(approxeq(mpe{1}(:), mpe{e}(:)))
  assert(approxeq(t1, te));
end

