function marginal = marginal_nodes(engine, nodes, t, add_ev)
% MARGINAL_NODES Compute the marginal on the specified query nodes (hmm)
% marginal = marginal_nodes(engine, nodes, t, add_ev)
%
% 'nodes' must be a single node.
% t is the time slice.

if nargin < 3, t = 1; end
if nargin < 4, add_ev = 0; end
assert(length(nodes)==1)
ss = engine.slice_size;

i = nodes(1);
bigT = engine.one_slice_marginal(:,t);
id = engine.marg_singleton_ndx_id(i);
dom = i + (t-1)*ss;

ndx = get_ndx(id, engine.ndx_type);
marginal.domain = dom;
marginal.T = marg_table_ndx(bigT, engine.maximize, ndx, engine.ndx_type);
marginal.mu = [];
marginal.Sigma = [];

if add_ev
  marginal = add_ev_to_dmarginal(marginal, engine.evidence, engine.node_sizes);
end    
 
