function marginal = marginal_nodes(engine, query, add_ev)
% MARGINAL_NODES Compute the marginal on the specified query nodes (jtree)
% marginal = marginal_nodes(engine, query, add_ev)
%
% 'query' must be a subset of some clique; an error will be raised if not.
% add_ev is an optional argument; if 1, we will "inflate" the marginal of observed nodes
% to their original size, adding 0s to the positions which contradict the evidence


if length(query) ~= 1
  error(['can only handle queries on single nodes, not' num2str(query)]);
end

if nargin < 3, add_ev = 0; end

c = engine.clq_ass_to_node(query);
marginal.domain = query;
ndx = get_ndx(engine.marg_node_ndx_id(query), engine.ndx_type);
marginal.T = marg_table_ndx(engine.clpot{c}, engine.maximize, ndx, engine.ndx_type);

if add_ev
  marginal = add_ev_to_dmarginal(marginal, engine.evidence, engine.actual_node_sizes);
end
