/* C mex version for multiply_by_pot.m in potential/@dpot directory */
/* 2 input, 1 output         */
/* bigpot, smallpot          */
/* bigpot with new "T" field */

#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
  int     i, j, siz_b, siz_s, count, NB, NS, ndim;
  double  *pbDomain, *psDomain, *pbSizes, *psSizes, *yrp, *zrp, *zrend, value;
  int     *mask, *sx, *sy, *cpsy, *subs, *s, *cpsy2;
  mxArray *ptemp;
  
  plhs[0] = mxDuplicateArray(prhs[0]);
  ptemp = mxGetField(plhs[0], 0, "T");
  zrp = mxGetPr(ptemp);
  ptemp = mxGetField(plhs[0], 0, "T");
  NB = mxGetNumberOfElements(ptemp);
  ptemp = mxGetField(plhs[0], 0, "domain");
  pbDomain = mxGetPr(ptemp);
  siz_b = mxGetNumberOfElements(ptemp);
  ptemp = mxGetField(plhs[0], 0, "sizes");
  pbSizes = mxGetPr(ptemp);
  
  ptemp = mxGetField(prhs[1], 0, "T");
  NS = mxGetNumberOfElements(ptemp);
  yrp = mxGetPr(ptemp);
  ptemp = mxGetField(prhs[1], 0, "domain");
  psDomain = mxGetPr(ptemp);
  siz_s = mxGetNumberOfElements(ptemp);
  ptemp = mxGetField(prhs[1], 0, "sizes");
  psSizes = mxGetPr(ptemp);
  
  
  if(NS == 1){
	  value = *yrp;
	  if(value == 0) value = 1;
	  for(i=0; i<NB; i++){
        *zrp++ /= value;
	  }
      return;
  }

  if(NS == NB){
    for(i=0; i<NB; i++){
	  value = *yrp++;
	  if(value != 0) *zrp /= value;
	  zrp++;
    }
    return;
  }
  
  mask = malloc(siz_s * sizeof(int));
  count = 0;
  for(i=0; i<siz_s; i++){
    for(j=0; j<siz_b; j++){
      if(psDomain[i] == pbDomain[j]){
	mask[count] = j;
	count++;
	break;
      }
    }
  }
  
  ndim = siz_b;
  sx = (int *)malloc(sizeof(int)*ndim);
  sy = (int *)malloc(sizeof(int)*ndim);
  for(i=0; i<ndim; i++){
    sx[i] = (int)pbSizes[i];
    sy[i] = 1;
  }
  for(i=0; i<count; i++){
    sy[mask[i]] = (int)psSizes[i];
  }
  
  s = (int *)malloc(sizeof(int)*ndim);
  *(cpsy = (int *)malloc(sizeof(int)*ndim)) = 1;
  subs =   (int *)malloc(sizeof(int)*ndim);
  cpsy2 =  (int *)malloc(sizeof(int)*ndim);
  for(i = 0; i < ndim; i++){
    subs[i] = 0;
    s[i] = sx[i] - 1;
  }
  
  for(i = 0; i < ndim-1; i++){
    cpsy[i+1] = cpsy[i]*sy[i]--;
    cpsy2[i] = cpsy[i]*sy[i];
  }
  cpsy2[ndim-1] = cpsy[ndim-1]*(--sy[ndim-1]);
  
  zrend = zrp + NB;
  while(zrp < zrend){
	value = *yrp;
	if(value != 0) *zrp /= value;
    zrp++;
    for(i = 0; i < ndim; i++){
      if (subs[i] == s[i]){
    	subs[i] = 0;
    	if (sy[i])
	       yrp -= cpsy2[i];
      }
      else{
    	subs[i]++;
    	if (sy[i])
    	  yrp += cpsy[i];
    	break;
      }
    }
  }
  free(sx);
  free(sy);
  free(s);
  free(cpsy);
  free(subs);
  free(cpsy2);
  free(mask);
}



