function id = add_ndx(bigdom, smalldom, ns, ndx_type)
% ADD_NDX Possibly add new indexes to the global cache
% id = add_ndx(bigdom, smalldom, ns, ndx_type)
%
% ns is the node sizes of all nodes
% id is the identifier for the cache entry, new or existing.

global SD_NDX SD_UID_GEN     B_NDX B_UID_GEN     D_NDX D_UID_GEN   

switch ndx_type
 case 'SD', 
  [id, newid, SD_UID_GEN] = mk_uid(SD_UID_GEN, {ns(bigdom), find_equiv_posns(smalldom, bigdom)});
  if newid
    [ndx.small, ndx.diff] = mk_ndxSD(bigdom, smalldom, ns);
    SD_NDX{id} = ndx;
  end
 case 'D',
  [id, newid, D_UID_GEN] = mk_uid(D_UID_GEN, {ns(bigdom), find_equiv_posns(smalldom, bigdom)});
  if newid
    D_NDX{id} = mk_ndxD(bigdom, smalldom, ns);   
  end
 case 'B',
  [id, newid, B_UID_GEN] = mk_uid(B_UID_GEN, {ns(bigdom), find_equiv_posns(smalldom, bigdom)});
  if newid
    B_NDX{id} = mk_ndxB(bigdom, smalldom, ns);   
  end
 otherwise, error(['unrecognized ndx type ' ndx_type])
end
